---
title: llarp::vpn::Platform
summary: a vpn platform responsible for obtaining vpn interfaces 

---

# llarp::vpn::Platform



a vpn platform responsible for obtaining vpn interfaces 


`#include <vpn.hpp>`

Inherited by [llarp::apple::VPNPlatform](Classes/classllarp_1_1apple_1_1VPNPlatform.md), [llarp::vpn::AndroidPlatform](Classes/classllarp_1_1vpn_1_1AndroidPlatform.md), [llarp::vpn::LinuxPlatform](Classes/classllarp_1_1vpn_1_1LinuxPlatform.md), [llarp::vpn::Win32Platform](Classes/classllarp_1_1vpn_1_1Win32Platform.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[Platform](Classes/classllarp_1_1vpn_1_1Platform.md#function-platform)**() =default |
| | **[Platform](Classes/classllarp_1_1vpn_1_1Platform.md#function-platform)**(const [Platform](Classes/classllarp_1_1vpn_1_1Platform.md) & ) =delete |
| | **[Platform](Classes/classllarp_1_1vpn_1_1Platform.md#function-platform)**([Platform](Classes/classllarp_1_1vpn_1_1Platform.md) && ) =delete |
| virtual | **[~Platform](Classes/classllarp_1_1vpn_1_1Platform.md#function-~platform)**() =default |
| virtual std::shared_ptr< [NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) > | **[ObtainInterface](Classes/classllarp_1_1vpn_1_1Platform.md#function-obtaininterface)**([InterfaceInfo](Classes/structllarp_1_1vpn_1_1InterfaceInfo.md) info, [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * router) =0<br>get a new network interface fully configured given the interface info blocks until ready, throws on error  |
| virtual [IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md) & | **[RouteManager](Classes/classllarp_1_1vpn_1_1Platform.md#function-routemanager)**() =0<br>get owned ip route manager for managing routing table  |

## Public Functions Documentation

### function Platform

```cpp
Platform() =default
```


### function Platform

```cpp
Platform(
    const Platform & 
) =delete
```


### function Platform

```cpp
Platform(
    Platform && 
) =delete
```


### function ~Platform

```cpp
virtual ~Platform() =default
```


### function ObtainInterface

```cpp
virtual std::shared_ptr< NetworkInterface > ObtainInterface(
    InterfaceInfo info,
    AbstractRouter * router
) =0
```

get a new network interface fully configured given the interface info blocks until ready, throws on error 

**Reimplemented by**: [llarp::vpn::AndroidPlatform::ObtainInterface](Classes/classllarp_1_1vpn_1_1AndroidPlatform.md#function-obtaininterface), [llarp::vpn::LinuxPlatform::ObtainInterface](Classes/classllarp_1_1vpn_1_1LinuxPlatform.md#function-obtaininterface), [llarp::vpn::Win32Platform::ObtainInterface](Classes/classllarp_1_1vpn_1_1Win32Platform.md#function-obtaininterface), [llarp::apple::VPNPlatform::ObtainInterface](Classes/classllarp_1_1apple_1_1VPNPlatform.md#function-obtaininterface)


### function RouteManager

```cpp
virtual IRouteManager & RouteManager() =0
```

get owned ip route manager for managing routing table 

**Reimplemented by**: [llarp::apple::VPNPlatform::RouteManager](Classes/classllarp_1_1apple_1_1VPNPlatform.md#function-routemanager), [llarp::vpn::AndroidPlatform::RouteManager](Classes/classllarp_1_1vpn_1_1AndroidPlatform.md#function-routemanager), [llarp::vpn::LinuxPlatform::RouteManager](Classes/classllarp_1_1vpn_1_1LinuxPlatform.md#function-routemanager), [llarp::vpn::Win32Platform::RouteManager](Classes/classllarp_1_1vpn_1_1Win32Platform.md#function-routemanager)


-------------------------------

Updated on 2022-06-03 at 22:54:39 +0000