---
title: llarp::AndroidLogStream

---

# llarp::AndroidLogStream





Inherits from [llarp::ILogStream](Classes/structllarp_1_1ILogStream.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual void | **[PreLog](Classes/structllarp_1_1AndroidLogStream.md#function-prelog)**(std::stringstream & s, LogLevel lvl, std::string_view filename, int lineno, const std::string & nodename) const override |
| virtual void | **[Print](Classes/structllarp_1_1AndroidLogStream.md#function-print)**(LogLevel lvl, std::string_view filename, const std::string & msg) override |
| virtual void | **[PostLog](Classes/structllarp_1_1AndroidLogStream.md#function-postlog)**(std::stringstream & ) const override |
| virtual void | **[Tick](Classes/structllarp_1_1AndroidLogStream.md#function-tick)**(llarp_time_t now) override<br>called every end of event loop tick  |
| virtual void | **[ImmediateFlush](Classes/structllarp_1_1AndroidLogStream.md#function-immediateflush)**() override<br>A blocking call to flush to disk. Should only be called in rare circumstances.  |

## Additional inherited members

**Public Functions inherited from [llarp::ILogStream](Classes/structllarp_1_1ILogStream.md)**

|                | Name           |
| -------------- | -------------- |
| virtual | **[~ILogStream](Classes/structllarp_1_1ILogStream.md#function-~ilogstream)**() =default |
| virtual void | **[AppendLog](Classes/structllarp_1_1ILogStream.md#function-appendlog)**(LogLevel lvl, std::string_view filename, int lineno, const std::string & nodename, const std::string msg) |


## Public Functions Documentation

### function PreLog

```cpp
virtual void PreLog(
    std::stringstream & s,
    LogLevel lvl,
    std::string_view filename,
    int lineno,
    const std::string & nodename
) const override
```


**Reimplements**: [llarp::ILogStream::PreLog](Classes/structllarp_1_1ILogStream.md#function-prelog)


### function Print

```cpp
virtual void Print(
    LogLevel lvl,
    std::string_view filename,
    const std::string & msg
) override
```


**Reimplements**: [llarp::ILogStream::Print](Classes/structllarp_1_1ILogStream.md#function-print)


### function PostLog

```cpp
virtual void PostLog(
    std::stringstream & 
) const override
```


**Reimplements**: [llarp::ILogStream::PostLog](Classes/structllarp_1_1ILogStream.md#function-postlog)


### function Tick

```cpp
virtual void Tick(
    llarp_time_t now
) override
```

called every end of event loop tick 

**Reimplements**: [llarp::ILogStream::Tick](Classes/structllarp_1_1ILogStream.md#function-tick)


### function ImmediateFlush

```cpp
inline virtual void ImmediateFlush() override
```

A blocking call to flush to disk. Should only be called in rare circumstances. 

**Reimplements**: [llarp::ILogStream::ImmediateFlush](Classes/structllarp_1_1ILogStream.md#function-immediateflush)


-------------------------------

Updated on 2022-06-03 at 22:54:38 +0000